package com.eactive.eai.rms.onl.manage.useDate;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.eactive.eai.agent.command.CommonCommand;
import com.eactive.eai.rms.common.base.OnlBaseAnnotationController;
import com.eactive.eai.rms.common.combo.ComboService;
import com.eactive.eai.rms.common.combo.ComboVo;
import com.eactive.eai.rms.common.util.CamelCaseUtil;
import com.eactive.eai.rms.common.vo.JsonPageVo;

/**
 * <pre>
 *     1. 기능 : 인터페이스 거래일자 제어 어댑터  관리 화면의 컨트롤러
 * </pre>
 *
 * @author : 
 * @version : $Revision: 1.24 $
 * @since : rms 1.0
 */

@Controller
public class UseDateControlController extends OnlBaseAnnotationController  {

	@Autowired
	@Qualifier("useDateControlService")
	private UseDateControlService service; 
	
	@Autowired
	private ComboService comboService;
	
	
	@RequestMapping(value= "/onl/admin/useDate/useDateControlMan.view")
	private String viewList(HttpServletRequest request, @RequestParam(value = "cmd", required = false ) String cmd ) throws Exception {
		if (cmd == null || "LIST".equals(cmd.toUpperCase())){
			cmd = "";
		}else {
			cmd = CamelCaseUtil.converCamelCase(cmd);
		}
		String path = request.getServletPath();
		return path.split("[.]")[0]+cmd;
	}
	
	/**
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	@RequestMapping(value= "/onl/admin/useDate/useDateControlMan.json", params = "cmd=LIST")
	private ModelAndView selectList(HttpServletRequest request,JsonPageVo pageVo ,String searchName) throws Exception {
		
		HashMap map = service.selectList(pageVo.getStartNum(), pageVo.getEndNum(), searchName);
		
		pageVo.setTotalCount((Integer)map.get("totalCount"));
		
		Map resultMap = new HashMap();
		resultMap.put("total"  , pageVo.getTotal());  //전체 페이지수
		resultMap.put("page"   , pageVo.getPage());   //현재 페이지수
		resultMap.put("records", pageVo.getTotalCount());//전체 레코드건수	
		resultMap.put("rows"   , map.get("list"));
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);
		return modelAndView;
		
	}


	@RequestMapping(value= "/onl/admin/useDate/useDateControlMan.json",params = "cmd=DETAIL")
	private ModelAndView selectDetail(HttpServletRequest request,
			HttpServletResponse response,String name) throws Exception {
		
		HashMap map = service.selectDetail(name);

		ModelAndView modelAndView = new ModelAndView("jsonView",map);	
		
		return modelAndView;
	}

	
	@RequestMapping(value= "/onl/admin/useDate/useDateControlMan.json",params = "cmd=UPDATE")
	private String insert(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String,Object> map) throws Exception {

		service.merge(map);

    	CommonCommand command = new CommonCommand("com.eactive.eai.agent.useDate.ReloadUseDateControlCommand",map.get("name"));
		agentUtilService.broadcast(command);
		
		return null;
		
	}
	@RequestMapping(value= "/onl/admin/useDate/useDateControlMan.json",params = "cmd=DELETE")
	private String delete(HttpServletRequest request,
			HttpServletResponse response, String name ) throws Exception {
		HashMap paramMap = new HashMap();
		paramMap.put("name", name);		
		service.delete(paramMap);
		CommonCommand command = new CommonCommand("com.eactive.eai.agent.useDate.RemoveUseDateControlCommand",name);
		agentUtilService.broadcast(command);
		return null;
		
	}
	@RequestMapping(value= "/onl/admin/useDate/useDateControlMan.json",params = "cmd=LIST_INIT_COMBO")
    public ModelAndView initCombo( HttpServletRequest request,
            HttpServletResponse response) throws Exception {

		List<ComboVo> useYnRows	= comboService.getFromCode("USE_YN");
        
		Map resultMap = new HashMap();
		resultMap.put("useYnRows"	, useYnRows);
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);		
		return modelAndView;            
    }
	

}